/*******************************************************************************
* [ Cmmsdk.h ]
* Header file for API fuctions in CMMSDK library for Labview
* - Update Data: 2019/04/03
* - Provider: COMIZOA Co., Ltd.
* - Phone: +82-42-936-6500~6
* - Fax  : +82-42-936-6507
* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
********************************************************************************/

typedef enum {COMW, OTPW, BUF0, BUF1}TMCWAddr;
typedef enum {MSTSW, SSTSW}TMCRAddr;

// Motion Chip Registers //
enum {
	PRMV, PRFL, PRFH, PRUR, PRDR, PRMG, PRDP, PRMD, PRIP, PRUS, PRDS, PRCP5, PRCI,
	RMV=16, RFL, RFH, RUR, RDR, RMG, RDP, RMD, RIP, RUS, RDS, RFA, RENV1, RENV2, RENV3, RENV4, RENV5, RENV6, RENV7,
	RCUN1=35, RCUN2, RCUN3, RCUN4, RCMP1, RCMP2, RCMP3, RCMP4, RCMP5, RIRQ, RLTC1, RLTC2, RLTC3, RLTC4,
	RSTS=49, REST, RIST, RPLS, RSPD, PSDC,
	RCI=60, RCIC,
	RIPS=63
};

typedef enum _TCmint{
	cmFALSE, cmTRUE
}TCmint;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MIO Property ID
// <TCmMioPropId>  <TCmMioPropIdEx>   MIO Property ID Ÿ Դϴ. <TCmMioPropIdEx> 
// <TCmMioPropId>  ̸ ٲپ Դϴ.     ߿ ƹų ص ˴ϴ.
typedef enum _TCmMioPropId{
	cmALM_LOGIC,	cmALM_MODE,		cmCMP_LOGIC,	cmDR_LOGIC, cmEL_LOGIC,		cmEL_MODE,
	cmERC_LOGIC,	cmERC_OUT,		cmEZ_LOGIC,		cmINP_EN,	cmINP_LOGIC,	cmLTC_LOGIC,
	cmLTC_LTC2SRC,	cmORG_LOGIC,	cmSD_EN,		cmSD_LOGIC, cmSD_LATCH,		cmSD_MODE,
	cmSTA_MODE, 	cmSTA_TRG,		cmSTP_MODE,		cmCLR_CNTR, cmCLR_SIGTYPE,	cmCMP_PWIDTH,
	cmERC_ONTIME,	cmSVON_LOGIC,	cmERC_OUT_EL,	cmCNT_D_SRC,	cmCNT_G_SRC
}TCmMioPropId;

typedef enum _TCmMioPropIdEx{
	cmMPID_ALM_LOGIC,	cmMPID_ALM_MODE,	cmMPID_CMP_LOGIC,	cmMPID_DR_LOGIC,	cmMPID_EL_LOGIC,	cmMPID_EL_MODE,
	cmMPID_ERC_LOGIC,	cmMPID_ERC_OUT,		cmMPID_EZ_LOGIC,	cmMPID_INP_EN,		cmMPID_INP_LOGIC,	cmMPID_LTC_LOGIC,
	cmMPID_LTC_LTC2SRC,	cmMPID_ORG_LOGIC,	cmMPID_SD_EN,		cmMPID_SD_LOGIC,	cmMPID_SD_LATCH,	cmMPID_SD_MODE,
	cmMPID_STA_MODE,	cmMPID_STA_TRG,		cmMPID_STP_MODE,	cmMPID_CLR_CNTR,	cmMPID_CLR_SIGTYPE,	cmMPID_CMP_PWIDTH,
	cmMPID_ERC_ONTIME,	cmMPID_SVON_LOGIC,	cmMPID_ERC_OUT_EL,	cmMPID_CNT_D_SRC,	cmMPID_CNT_G_SRC,	cmMPID_HOME_ESC_DIS,
	cmMPID_LTC_TRGSRC,	cmMPID_EN_ARDP, cmSWL_MODE
}TCmMioPropIdEx;

// Bit order of StReadMioStatuses() return value  //
typedef enum _TCmMioState{
	cmIOST_RDY,	cmIOST_ALM, cmIOST_ELP,		cmIOST_ELN,
	cmIOST_ORG, cmIOST_DIR, cmIOST_RSV1,	cmIOST_PCS,
	cmIOST_ERC, cmIOST_EZ,	cmIOST_CLR,		cmIOST_LTC,
	cmIOST_SD,	cmIOST_INP, cmIOST_DRP,		cmIOST_DRN,
	cmIOST_STA, cmIOST_STP, cmIOST_SVON
}TCmMioState;

// Motion operation status ID //
typedef enum _TCmMotionState{
	cmMST_STOP, cmMST_WAIT_DR, cmMST_WAIT_STA, cmMST_WAIT_INSYNC,
	cmMST_WAIT_OTHER, cmMST_WAIT_ERC, cmMST_WAIT_DIR, cmMST_RESERVED1, cmMST_WAIT_PLSR,
	cmMST_IN_RVSSPD, cmMST_IN_INISPD, cmMST_IN_ACC, cmMST_IN_WORKSPD, cmMST_IN_DEC,
	cmMST_WAIT_INP, cmMST_SPARE0
}TCmMotionState;

// Signal logic definition //
typedef enum _TCmSigLogic{
	cmLOGIC_A=0 /*Normal open*/, cmLOGIC_B=1/*Normal close*/
}TCmSigLogic;

// Axis index definition //
typedef enum _TCmAxis{
	cmX1, cmY1, cmZ1, cmU1, cmX2, cmY2, cmZ2, cmU2
}TCmAxis;

// Definition for axes mask  //
typedef enum _TCmAxisMask{
	cmX1_MASK=0x1, cmY1_MASK=0x2, cmZ1_MASK=0x4, cmU1_MASK=0x8,
	cmX2_MASK=0x10, cmY2_MASK=0x20, cmZ2_MASK=0x40, cmU2_MASK=0x80
}TCmAxisMask;

// Encoder and PA/PB input mode definition //
typedef enum _TCmInMode{
	cmIMODE_AB1X, cmIMODE_AB2X, cmIMODE_AB4X, cmIMODE_CWCCW, cmIMODE_STEP
}TCmInMode;

// Command output mode definition //
typedef enum _TCmOutMode{
	cmOMODE_PDIR0, cmOMODE_PDIR1, cmOMODE_PDIR2, cmOMODE_PDIR3,
	cmOMODE_CWCCW0, cmOMODE_CWCCW1, cmOMODE_CCWCW0, cmOMODE_CCWCW1,
	cmOMODE_AB1, cmOMODE_AB2
}TCmOutMode;

// Control Mode //
typedef enum _TCmCtrlMode{
	cmCTRL_OPEN, // Open loop control mode
	cmCTRL_SEMI_C, // Semi-closed loop control mode (applied only to absolute in-position commands)
	cmCTRL_FULL_C // Full-closed loop control mode (this is not supported at current version)
}TCmCtrlMode;

// (Linear)Operation direction //
typedef enum _TCmDir{
	cmDIR_N /*(-)Dir*/, cmDIR_P /*(+)Dir*/
}TCmDir;

// Counter name //
typedef enum _TCmCntr {
	cmCNT_COMM/*Command*/, cmCNT_FEED/*Feedback*/, cmCNT_DEV/*Deviation*/,
	cmCNT_GEN/*General*/, cmCNT_REM/*Remained*/
}TCmCntr;

// Speed mode index definition //
typedef enum _TCmSpeedMode{
	cmSMODE_KEEP=-1/* Keep previous setting*/, cmSMODE_C=0 /*Constant */, cmSMODE_T /*Trapeziodal*/, cmSMODE_S /*S-curve*/
}TCmSpeedMode;

// Arc operation direction //
typedef enum _TCmArcDir{
	cmARC_CW, cmARC_CCW
}TCmArcDir;

// Compare Method //
typedef enum _TCmCmpMethod{
	cmDISABLE, cmEQ_BIDIR, cmEQ_PDIR, cmEQ_NDIR, cmLESS/*Cnt<Data*/, cmGREATER/*Cnt>Data*/
}TCmCmpMethod;

// Action when general comparator met the condition //
typedef enum _TCmCmpAction{
	cmEVNT_ONLY, cmEVNT_IS, cmEVNT_DS, cmEVNT_SPDCHG
}TCmCmpAction;

// Backlash/Slip correction mode //
typedef enum _TCmCorrMode{
	cmCORR_DIS, // Disable correction
	cmCORR_BACK, // Backlash correction mode
	cmCORR_SLIP // Slip correction mode
}TCmCorrMode;

typedef enum _TCmExtOptionId{
	cmEXOPT_SET_USE_PREREG
}TCmExtOptionId;

// Interrupt Handler Type //
typedef enum _TCmIntHandlerType{
	cmIHT_MESSAGE=0, cmIHT_EVENT, cmIHT_CALLBACK
}TCmIntHandlerType;

// Interrupt Mask
typedef enum _TCmIntMaskType{
	cmINT_IREN=0,	cmINT_IRN,		cmINT_IRNM,		cmINT_IRND,		cmINT_IRUS,
	cmINT_IRUE,		cmINT_IRDS,		cmINT_IRDE,		cmINT_IRC1,		cmINT_IRC2,
	cmINT_IRC3,		cmINT_IRC4,		cmINT_IRC5,		cmINT_IRCL,		cmINT_IRLT,
	cmINT_IROL,		cmINT_IRSD,		cmINT_IRDR,		cmINT_IRSA
}TCmIntMaskType;

// Interrupt Handler Type //
typedef enum _TCmStringID{
	cmSTR_AXIS_NAME, cmSTR_DIST_UNIT, cmSTR_SPEED_UNIT
}TCmStringID;

// Sequence Mode //
typedef enum _TCmSeqMode{
	cmSEQM_SKIP_RUN, cmSEQM_WAIT_RUN
}TCmSeqMode;

// Map Type //
typedef enum _TCmDevMapType{
	cmDMAP_MOTION, cmDMAP_DIO, cmDMAP_ALL
}TCmDevMapType;

// SetFilterAB  //
typedef enum _TCmABFilter{
	cmAB_ENC, cmAB_PULSAR
}TCmABFilter;

// Axis Capability ID //
typedef enum _TCmAxisCapID{
	cmCAPX_CMD_DIR=0, /* Command direction change function */
	cmCAPX_EL_MAN_SET, /* -/+EL Manual control function */
	cmCAPX_CMP_HIGH /* High-speed Compare Output function */
}TCmAxisCapID;

typedef enum _TCmHomePosClrMode{
	cmHPCM_M0, // ORG(/EL/EZ) ȣ ߻  COMMAND & FEEDBACK ġ 0 ŬѴ.
	cmHPCM_M1, // ͸  Ϸϰ  COMMAND & FEEDBACK ġ  0 ŬѴ.
	cmHPCM_M2,  // ͸  Ϸϰ  FEEDBACK ġ ״ ΰ COMMAND ġ FEEDBACK ġ ġŲ.
	cmHPCM_KEEP // ͸  Ϸϴ COMMAND & FEEDBACK ġ Ŭ ʴ´.
}TCmHomePosClrMode;


// Sync mode //
typedef enum _TCmSyncMode{
	cmSYNC_DISABLE,
	cmSYNC_INT_SYNC,
	cmSYNC_OTHER_STOP
}TCmSyncMode;

// Internal sync. conditions //
typedef enum _TCmIntSyncCond{
	cmISYNC_ACC_STA, // 0: at start of acceleration
	cmISYNC_ACC_END, // 1: at end of acceleration
	cmISYNC_DEC_STA, // 2: at start of deceleration
	cmISYNC_DEC_END, // 3: at end of deceleration
	cmISYNC_SLN, // 4: when (-)software limit met
	cmISYNC_SLP, // 5: when (+)software limit met
	cmISYNC_GCMP, // 6: when General Comparator condition is satisfied
	cmISYNC_TCMP, // 7: when Trigger Comparator condition is satisfied
}TCmIntSyncCond;

////////////////////////////////////////////////////////////////////////////////////////////
// TCmLmxSeqMode: ̼۸ Ϸ ϴµ LMX Buffer ̹  ִ 쿡  ó
//    ̵.
// -. cmLMX_SEQM_SKIP_RUN: 'cmERR_LMX_ADD_ITEM_FAIL' ߻ϰ Լ ٷ ȯȴ.
// -. cmLMX_SEQM_WAIT_RUN: LMX ۿ free space   ϰ ִٰ free space
//     ϰ Լ ȯȴ.
typedef enum _TCmLmxSeqMode{
	cmLMX_SEQM_SKIP_RUN,
	cmLMX_SEQM_WAIT_RUN
}TCmLmxSeqMode;


////////////////////////////////////////////////////////////////////////////////////////////
// TCmLmxStsId: cmmLmxGetSts() Լ ؼ о status ID  
typedef enum _TCmLmxStsId{
	cmLMX_STARTED, // Lmx  Ȱȭ Ǿ Ÿ status
	cmLMX_BUSY, // Lmx   ̼   Ÿ status
	cmLMX_FREE_SPACE, // Lmx   . ȯǴ  Ʈ  ƴ϶   ִ  ̴.
	cmLMX_RUN_ITEM_NO, //  ̼۵ǰ ְų  ̼۵ Item ȣ.
	cmLMX_RUN_ITEM_ID, //  ̼۵ǰ ְų  ̼۵ Item ̵(̵ cmmLmxSetNextItemId() Լ ؼ Ѵ)
	cmLMX_LAST_SET_ITEM_ID, //   Item ̵.
	//cmLMX_LAST_SET_ITEM_NO  //   Item ̵[Ŀ ߰].
}TCmLmxStsId;

////////////////////////////////////////////////////////////////////////////////////////////
// Debug-log level ID
typedef enum _TCmLogLevel{
	cmLOG_LEVEL_DISABLED, // disable logging
	cmLOG_LEVEL_ERROR,	// log only when error occurs
	cmLOG_LEVEL_COMM,	// log command functions and error (including error occurs)
	cmLOG_LEVEL_GET,	// log get functions, command functions and error (except cmmSxIsDone(), cmmStGetPostion(), ...)
	cmLOG_LEVEL_ALL		// log all functions
}TCmDbgLogLevel;

////////////////////////////////////////////////////////////////////////////////////////////
// Debug-log level ID
typedef enum _TCmManLogMode{
	cmMAN_LOG_DISABLED, // no effect on manual log action
	cmMAN_LOG_SKIP,		// skip logging until cmmDlogExitManCtl() is called
	cmMAN_LOG_ADD		// log any functions regardless of log level until cmmDlogExitManCtl() is called.
	                    // But, cmMAN_LOG_ADD has no effect if log level is 0 (disabled)
}TCmManLogMode;



typedef struct {
	double fCmndPos, fFeedPos;
	double fCmndVel, fFeedVel;
	int	nMst;
	unsigned int dwMio;
	unsigned int dwReserved[2];
}TAxisMstPack;

typedef struct{
	unsigned int nScanCount;
	TAxisMstPack Axis[64];
}TCmMstAll;


//***********************************************************************************************
//								FUNCTION Prototype												*
//***********************************************************************************************

// Interrupt Handler Callback Function Prototype //
typedef void (WINAPI *TIntHandler) (LPVOID lParam);


//***********************************************************************************************
//								Structures														*
//***********************************************************************************************

//------------------- Motion Device Informations -------------------------------------------------------//

// Informations of a motion device //
typedef struct{
	unsigned short wDeviceId, wDevInstance;
	short wSlot;
	unsigned short wNumAxes, wIniAxis;
	unsigned short wDiNum, wDoNum;
	void*  pDevClass; //   ̺귯 ο ϴ ̴.
}TMotDevInfo;

// Informations of all actually installed motion devices //
typedef struct{
	unsigned short wNumDevs; // Number of installed motion devices
	TMotDevInfo Dev[CMM_MAX_NUM_MOT_DEV];
}TMotDevEnum;

// Informations of motion devices defined by user //
typedef struct{
	unsigned short wNumDevs;
	TMotDevInfo Dev[CMM_MAX_NUM_MOT_DEV];
}TMotDevMap;

//------------------- DIO Device Informations -----------------------------------------------------------//

// Informations of a DIO device //
typedef struct{
	unsigned short	wDeviceId, wDevInstance;
	short 	wSlot;
	unsigned short	wDiNum, wDiIniChan;
	unsigned short	wDoNum, wDoIniChan;
	int	bMotionDevice;
	HANDLE	Handle; // ġΰ쿡 CMotionDevice Ŭ , SD4xx ġ 쿡 Device Handle
}TDioDevInfo;

// Informations of all actually installed DIO devices //
typedef struct{
	unsigned short wNumDevs;
	TDioDevInfo Dev[CMM_MAX_NUM_DIO_DEV];
}TDioDevEnum;

// Informations of DIO devices defined by user//
typedef struct{
	unsigned short wNumDevs, wNumAllDiChan, wNumAllDoChan;
	TDioDevInfo Dev[CMM_MAX_NUM_DIO_DEV];
}TDioDevMap;

//-------------------- MOTION CONFIGURATION ------------------------------------------------------------//
typedef union{
	struct{
		// B0 ~ B3 //
		unsigned long ALM_Logic: 1;
		unsigned long ALM_Mode : 1;
		unsigned long CMP_Logic: 1;
		unsigned long DR_Logic: 1;
		// B4 ~ B7 //
		unsigned long EL_Logic: 1;
		unsigned long EL_Mode: 1;
		unsigned long ERC_Logic: 1;
		unsigned long ERC_OutAtHome: 1;
		// B8 ~ B11 //
		unsigned long EZ_Logic: 1;
		unsigned long INP_Enable: 1;
		unsigned long INP_Logic: 1;
		unsigned long LTC_Logic: 1;
		// B12 ~ B15 //
		unsigned long LTC_Ltc2Src: 1;
		unsigned long ORG_Logic: 1;
		unsigned long SD_Enable: 1;
		unsigned long SD_Logic: 1;
		// B16 ~ B19 //
		unsigned long SD_Latch: 1;
		unsigned long SD_Mode: 1;
		unsigned long STA_Mode: 1;
		unsigned long STA_TrgType: 1;
		// B20 ~ B21 //
		unsigned long STP_Mode_Old: 1; //   ʴ Ʈ
		unsigned long SVON_Logic: 1;
        unsigned long STP_Mode: 2;
		unsigned long Reserved: 8;
	}b;
	unsigned long v;
}TCmeMio1;

typedef struct {
	short CLR_CntrSel;
	short CLR_SigType;
	long CMP_PulseWidth;
	short ERC_OnTime;
}TCmeMio2;

typedef struct{
	long HomeMode;
	long EzCount;
	double EscDist;
	double Offset;
	long nVMode;
	double fVel, fAcc, fDec, fRevVel;
}TCmeHome;

// 140616 YJB - ActSpdFilter
typedef struct {
	long bEnable;
	double fCutOffFreq;
}TFilter;

typedef struct{
	
	char szAxisName[31];//[CMM_MAX_STR_LEN_AXIS_TITLE+1];
	char szDistText[31];//[CMM_MAX_STR_LEN_DIST_UNIT+1];
	char szVelText[31];//[CMM_MAX_STR_LEN_VEL_UNIT+1];
	TCmeMio1 Mio1;
	TCmeMio2 Mio2;
	double fInOutRatio;
	double fUnitDist, fUnitSpeed, fMaxSpeed;
	
	// Pulse output mode //
	struct{
		unsigned int nMode:		4; // Output Mode Index
		unsigned int bReverse:	2; // Reverse CW/CCW, this is valid when nMode is 4 or 5(two pulse mode).
		unsigned int Reserved:	26;
	}OutMode;
	
	// Encoder input mode //
	struct{
		unsigned int nMode:		4; // Encoder input mode index
		unsigned int bReverse:	2; // Reverse encoder direction
		unsigned int bApplyFilter: 1; // Apply Filter to EA/EB input
		unsigned int Reserved:	25;
	}InMode;
	
	// Software limit config //
	struct{
		short IsEnable;
		double LimitN, LimitP;
	}SoftLimit;
	
	// Slip/Backlash correction config //
	struct{
		unsigned short Mode, CntrMask;
		double Amount, Vel;
	}Correction;

	// FH Correction config //
	struct{
		int bEnable;
		double Ratio;
	}VworkCorr;

	unsigned long dwIntMask; // Event Interrupt Mask

	// Etc. config //
	struct{
		unsigned int bFilterEn: 1;
		unsigned int nCtrlMode: 4;
		unsigned int bSimulMode: 1;
		unsigned int bFilterPAPB: 1;
		unsigned int nElnManMode: 2; // 0=>Sensor Է , 1=> OFF, 2=> ON
		unsigned int nElpManMode: 2; // 0=>Sensor Է , 1=> OFF, 2=> ON
		unsigned int Reserved: 21;
	}Etc1;

	TCmeHome Home;
	long nVMode;
	double fVelIni, fVelWork, fAcc, fDec;
	long nHPCM; // Home Position Clear Mode [Added at 2007/01/12]

	long bActSpdEnable;
	double fCutOffFreq;

	unsigned long dwReserved[251];
}TCmeAxis;

//------------------------------------------------------------------------------------------------------//
typedef struct{
	struct{
		int bEnable;
		unsigned long dwInterval;
	}ActSpdChk;
	int bShowErrorAuto;
	struct{
		short nLevel;
		char szFilePath[MAX_PATH];
	}Dlog;
	unsigned long dwReserved[100];
}TCmeGeneral;

//--------------------------------- CME FILE STRUCTURE (ALL) --------------------------------------------//

typedef struct{
	struct{
		unsigned int Major:	16;
		unsigned int Minor: 16;
	}Version;
	unsigned long dwReserved[100];
}TCmeFileHeader;

typedef struct{
	TMotDevMap DevMap_Mot;
	TDioDevMap DevMap_Dio;
	unsigned long dwDiLogics[16], dwDoLogics[16];
	TCmeAxis Axis[64];
	TCmeGeneral Gen;
}TCmeData_V2;

typedef struct _PT_MOTION_TAB {
	double *position;
	double *time;
	double total_time;
	long pointCnt;
} PT_MOTION_TAB;

typedef struct {
	int master_ms; // ms_no
	int groupID;
	float stop_time;
	float e_stop_time;
	int gantry_flag; // moving magnet : -1, no gantry algorithm : 0, semi gantry algorithm : 1, gantry algorithm master : 2, gantry algorithm slave : 3.
	int master_axis_no; //    ȣ 
	int axis_cnt; //   
	int axis_no[12]; //   ȣ group  
	int motion_ms[12];
} MOTION_CONFIG;

//*******************************************************************************************************
//								API FUNCTIONS                                                           *
//*******************************************************************************************************

//////////////////////////////////////////////////////////////////////////////////////////////////////////
// SetBit() :   Ư Ʈ  Ѵ. ũ̹Ƿ Լ ȣ  ʵʿ !
// v: , n:bitȣ, s:氪(state)
#define cmmSetBit(v,n,s)	if(s) (v)|=(1<<(n)); else (v)&=~(1<<(n))
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// GetBit() :   Ư Ʈ  ȯѴ. ũ̹Ƿ Լ ȣ  ʵʿ !
// v: , n:bitȣ
#define cmmGetBit(v,n)		(((v)>>(n))&0x1)

//====================== DLL LOAD/UNLOAD FUNCTIONS ============================================//
 int cmmLoadDll(void);
 void cmmUnloadDll(void);

//====================== General FUNCTIONS ====================================================//
 long _stdcall (cmmGnDeviceLoad)		(long IsResetDevice, long* NumAxes);
 long _stdcall (cmmGnDeviceUnload)		(void);
 long _stdcall (cmmGnDeviceIsLoaded)	(long* IsLoaded);
 long _stdcall (cmmGnDeviceReset)		(void);
 long _stdcall (cmmGnInitFromFile)		(const char *szCmeFile);
 long _stdcall (cmmGnInitFromFile_MapOnly)  (const char *szCmeFile, long MapType);
 long _stdcall (cmmGnSetServoOn)		(long Axis, long Enable);
 long _stdcall (cmmGnGetServoOn)		(long Axis, long* Enable);
 long _stdcall (cmmGnSetAlarmRes)		(long Axis, long IsOn);
 long _stdcall (cmmGnGetAlarmRes)		(long Axis, long* IsOn);
 long _stdcall (cmmGnPulseAlarmRes)	(long Axis, long IsOnPulse, long dwDuration, long IsWaitPulseEnd);
 long _stdcall (cmmGnSetSimulMode)		(long Axis, long IsSimulMode);
 long _stdcall (cmmGnGetSimulMode)		(long Axis, long* IsSimulMode);
 long _stdcall (cmmGnPutInternalSTA)	(long AxesMask);
 long _stdcall (cmmGnSetEmergency)   	(long IsEnable, long IsDecStop);
 long _stdcall (cmmGnGetEmergency)   	(long *IsEnabled);
 long _stdcall (cmmGnBitShift) 		(long Value, long ShiftOption, long* Result);

//====================== Configuration FUNCTIONS ==============================================//
 long _stdcall (cmmCfgSetMioProperty)	(long Axis, long PropId, long PropVal);
 long _stdcall (cmmCfgGetMioProperty) (long Axis, long PropId, long *PropVal);
 long _stdcall (cmmCfgSetFilter)		(long Axis, long IsEnable);
 long _stdcall (cmmCfgGetFilter)		(long Axis, long* IsEnabled);
 long _stdcall (cmmCfgSetFilterAB)		(long Channel, long Target, long IsEnable);
 long _stdcall (cmmCfgGetFilterAB)		(long Channel, long Target, long *IsEnabled);
 long _stdcall (cmmCfgSetInMode)		(long Axis, long InputMode, long IsReverse);
 long _stdcall (cmmCfgGetInMode)		(long Axis, long* InputMode, long* IsReverse);
 long _stdcall (cmmCfgSetOutMode)		(long Axis, long OutputMode);
 long _stdcall (cmmCfgGetOutMode)		(long Axis, long* OutputMode);
 long _stdcall (cmmCfgSetCtrlMode)		(long Axis, long CtrlMode);
 long _stdcall (cmmCfgGetCtrlMode)		(long Axis, long* CtrlMode);
 long _stdcall (cmmCfgSetInOutRatio)	(long Axis, double Ratio);
 long _stdcall (cmmCfgGetInOutRatio)	(long Axis, double* Ratio);
 long _stdcall (cmmCfgSetUnitDist)		(long Axis, double UnitDist);
 long _stdcall (cmmCfgGetUnitDist)		(long Axis, double* UnitDist);
 long _stdcall (cmmCfgSetUnitSpeed)	(long Axis, double UnitSpeed);
 long _stdcall (cmmCfgGetUnitSpeed)	(long Axis, double* UnitSpeed);
 long _stdcall (cmmCfgSetSpeedRange)	(long Axis, double MaxPPS);
 long _stdcall (cmmCfgGetSpeedRange)	(long Axis, double* MinPPS, double* MaxPPS);
 long _stdcall (cmmCfgSetSpeedPattern)	(long Axis, long SpeedMode, double WorkSpeed, double Accel, double Decel);
 long _stdcall (cmmCfgGetSpeedPattern)	(long Axis, long* SpeedMode, double* WorkSpeed, double* Accel, double* Decel);
 long _stdcall (cmmCfgSetSpeedPattern_T) (long Channel, long SpeedMode, double WorkSpeed, double AccelTime, double DecelTime); // <V5.0.4.0>
 long _stdcall (cmmCfgGetSpeedPattern_T) (long Channel, long* SpeedMode, double* WorkSpeed, double* AccelTime, double* DecelTime); // <V5.0.4.0>
 long _stdcall (cmmCfgSetVelCorrRatio)	(long Axis, double CorrRatio);
 long _stdcall (cmmCfgGetVelCorrRatio) (long Axis, double* CorrRatio);
 long _stdcall (cmmCfgSetMinCorrVel)	(long Axis, double MinVel); // <V5.0.4.0>
 long _stdcall (cmmCfgGetMinCorrVel)	(long Axis, double* MinVel); // <V5.0.4.0>
 long _stdcall (cmmCfgSetMinAccTime)	(long Axis, double MinAccT, double MinDecT); // <V5.0.4.0>
 long _stdcall (cmmCfgGetMinAccTime)	(long Axis, double* MinAccT, double* MinDecT); // <V5.0.4.0>
 long _stdcall (cmmCfgSetActSpdCheck)	(long IsEnable, long Interval);
 long _stdcall (cmmCfgGetActSpdCheck)	(long *IsEnable, long* Interval);
 long _stdcall (cmmCfgSetSoftLimit)	(long Axis, long IsEnable, double LimitN, double LimitP);
 long _stdcall (cmmCfgGetSoftLimit)	(long Axis, long* IsEnable, double* LimitN, double* LimitP);
 long _stdcall (cmmCfgSetRingCntr)		(long Axis, long TargCntr, long IsEnable, double CntMax);
 long _stdcall (cmmCfgGetRingCntr)		(long Axis, long TargCntr, long* IsEnable, double* CntMax);
 long _stdcall (cmmCfgSetSeqMode)		(long SeqMode);
 long _stdcall (cmmCfgGetSeqMode)		(long* SeqMode);
 long _stdcall (cmmCfgSetManExtLimit)	(long Axis, long IsSetELP, long IsEnable, long ManState);
 long _stdcall (cmmCfgGetManExtLimit)	(long Axis, long IsGetELP, long *IsEnable, long *ManState);
 long _stdcall (cmmCfgSetActSpdFilter)	(long Axis, long IsEnable, double fCutOffFreq);
 long _stdcall (cmmCfgSetLowSpdAlgorithm)	(long Axis, long Enable);
 long _stdcall (cmmCfgGetLowSpdAlgorithm)	(long Axis, long *Enabled);

//====================== HOME-RETURN FUNCTIONS ================================================//
 long _stdcall (cmmHomeSetConfig)		(long Axis, long HomeMode, long EzCount, double EscDist, double Offset);
 long _stdcall (cmmHomeGetConfig)		(long Axis, long* HomeMode, long* EzCount, double* EscDist, double* Offset);
 long 	_stdcall (cmmHomeSetPosClrMode)	(long Axis, long PosClrMode);
 long 	_stdcall (cmmHomeGetPosClrMode)	(long Axis, long* PosClrMode);
 long _stdcall (cmmHomeSetSpeedPattern)(long Axis, long SpeedMode, double Vel, double Accel, double Decel, double RevVel);
 long _stdcall (cmmHomeGetSpeedPattern)(long Axis, long* SpeedMode, double* Vel, double* Accel, double* Decel, double* RevVel);
 long _stdcall (cmmHomeSetSpeedPattern_T)(long Axis, long SpeedMode, double Vel, double AccelTime, double DecelTime, double RevVel);
 long _stdcall (cmmHomeGetSpeedPattern_T)(long Axis, long* SpeedMode, double* Vel, double* AccelTime, double* DecelTime, double* RevVel);
 long _stdcall (cmmHomeMoveStart)		(long Axis, long Direction);
 long _stdcall (cmmHomeMoveStartEx)	(long Channel, long Direction, long isExitConstSpeed, long exitTimeOutMs);
 long _stdcall (cmmHomeMoveStartEx2)	(long Channel, long Direction, long isExitConstSpeed);
 long _stdcall (cmmHomeMove)			(long Axis, long Direction, long IsBlocking);
 long _stdcall (cmmHomeMoveAll)		(long NumAxes, long* AxisList, long* DirList, long IsBlocking);
 long _stdcall (cmmHomeMoveAllStart)	(long NumAxes, long* AxisList, long* DirList);
 long _stdcall (cmmHomeGetSuccess)		(long Axis, long *IsSuccess);
 long _stdcall (cmmHomeSetSuccess)		(long Axis, long IsSuccess);
 long _stdcall (cmmHomeIsBusy)			(long Axis, long *IsBusy);
 long _stdcall (cmmHomeWaitDone)		(long Axis, long IsBlocking);

//====================== Single Axis Move FUNCTIONS ===========================================//
 long _stdcall (cmmSxSetSpeedRatio)	(long Axis, long SpeedMode, double VelRatio, double AccRatio, double DecRatio);
 long _stdcall (cmmSxGetSpeedRatio)	(long Axis, long* SpeedMode, double* VelRatio, double* AccRatio, double* DecRatio);
 long _stdcall (cmmSxMoveStart)		(long Axis, double Distance);
 long _stdcall (cmmSxMove)				(long Axis, double Distance, long IsBlocking);
 long _stdcall (cmmSxMoveToStart)		(long Axis, double Position);
 long _stdcall (cmmSxMoveTo)			(long Axis, double Position, long IsBlocking);
 long _stdcall (cmmSxVMoveStart)		(long Axis, long Dir);
 long _stdcall (cmmSxStop)				(long Axis, long IsWaitComplete, long IsBlocking);
 long _stdcall (cmmSxStopEmg)			(long Axis);
 long _stdcall (cmmSxIsDone)			(long Axis, long *IsDone);
 long _stdcall (cmmSxWaitDone)			(long Axis, long IsBlocking);
 long _stdcall (cmmSxGetTargetPos)		(long Channel, double* Position);
 long _stdcall (cmmSxOptSetIniSpeed)	(long Axis, double IniSpeed);
 long _stdcall (cmmSxOptGetIniSpeed)	(long Axis, double* IniSpeed);
 long _stdcall (cmmSxSetCorrection)	(long Axis, long CorrMode, double CorrAmount, double CorrVel, long CntrMask);
 long _stdcall (cmmSxGetCorrection)	(long Axis, long* CorrMode, double* CorrAmount, double* CorrVel, long* CntrMask);
 long _stdcall (cmmSxOptSetSyncMode)	(long Axis, long Mode, long RefAxis, long Condition);
 long _stdcall (cmmSxOptGetSyncMode)	(long Axis, long* Mode, long* RefAxis, long* Condition);
 long _stdcall (cmmSxOptSetSyncOut)	(long Axis, long Mode, long DoChan_local, long DoLogic);
 long _stdcall (cmmSxOptGetSyncOut)	(long Axis, long *Mode, long *DoChan_local, long *DoLogic);
 long _stdcall (cmmSxOptSetRdpOffset)	(long Axis, double OffsetDist);
 long _stdcall (cmmSxOptGetRdpOffset)	(long Axis, double* OffsetDist);

//====================== Multiple Axes Move FUNCTIONS =========================================//
 long	_stdcall (cmmMxMove)				(long NumAxes, long* AxisList, double* DistList, long IsBlocking);
 long	_stdcall (cmmMxVMoveStart)		(long NumAxes, long* AxisList, long* DirList);
 long	_stdcall (cmmMxMoveStart) 		(long NumAxes, long* AxisList, double* DistList);
 long	_stdcall (cmmMxMoveTo) 			(long NumAxes, long* AxisList, double* PosList, long IsBlocking);
 long	_stdcall (cmmMxMoveToStart)		(long NumAxes, long* AxisList, double* PosList);
 long	_stdcall (cmmMxStop) 			(long NumAxes, long* AxisList, long IsWaitComplete, long IsBlocking);
 long	_stdcall (cmmMxStopEmg) 			(long NumAxes, long* AxisList);
 long	_stdcall (cmmMxIsDone) 			(long NumAxes, long* AxisList, long *IsDone);
 long	_stdcall (cmmMxWaitDone) 		(long NumAxes, long* AxisList, long IsBlocking);

//====================== Interpolation Move FUNCTIONS =========================================//
 long	_stdcall (cmmIxMapAxes) 			(long MapIndex, long MapMask1, long MapMask2);
 long	_stdcall (cmmIxSetSpeedPattern)	(long MapIndex, long IsVectorSpeed, long SpeedMode, double Vel, double Acc, double Dec);
 long	_stdcall (cmmIxGetSpeedPattern)	(long MapIndex, long* IsVectorSpeed, long* SpeedMode, double* Vel, double* Acc, double* Dec);
 long	_stdcall (cmmIxSetSpeedPattern_T)(long MapIndex, long SpeedMode, double Vel, double AccelTime, double DecelTime); // <V5.0.4.0>
 long	_stdcall (cmmIxGetSpeedPattern_T)(long MapIndex, long* SpeedMode, double* Vel, double* AccelTime, double* DecelTime); // <V5.0.4.0>
 long	_stdcall (cmmIxLine) 			(long MapIndex, double* DistList, long IsBlocking);
 long	_stdcall (cmmIxLineStart) 		(long MapIndex, double* DistList);
 long	_stdcall (cmmIxLineTo) 			(long MapIndex, double* PosList, long IsBlocking);
 long	_stdcall (cmmIxLineToStart)		(long MapIndex, double* PosList);
 long	_stdcall (cmmIxLine_Fx) 			(long MapIndex, double* DistList, long IsBlocking);
 long	_stdcall (cmmIxLineStart_Fx) 		(long MapIndex, double* DistList);
 long	_stdcall (cmmIxLineTo_Fx) 			(long MapIndex, double* PosList, long IsBlocking);
 long	_stdcall (cmmIxLineToStart_Fx)		(long MapIndex, double* PosList);
 long	_stdcall (cmmIxArcA) 			(long MapIndex, double XCentOffset, double YCentOffset, double EndAngle, long IsBlocking);
 long	_stdcall (cmmIxArcAStart) 		(long MapIndex, double XCentOffset, double YCentOffset, double EndAngle);
 long	_stdcall (cmmIxArcATo) 			(long MapIndex, double XCent, double YCent, double EndAngle, long IsBlocking);
 long	_stdcall (cmmIxArcAToStart)		(long MapIndex, double XCent, double YCent, double EndAngle);
 long	_stdcall (cmmIxArcP) 			(long MapIndex, double XCentOffset, double YCentOffset, double XEndPointDist, double YEndPointDist, long Direction, long IsBlocking);
 long	_stdcall (cmmIxArcPStart) 		(long MapIndex, double XCentOffset, double YCentOffset, double XEndPointDist, double YEndPointDist, long Direction);
 long	_stdcall (cmmIxArcPTo) 			(long MapIndex, double XCent, double YCent, double XEndPos, double YEndPos, long Direction, long IsBlocking);
 long	_stdcall (cmmIxArcPToStart)		(long MapIndex, double XCent, double YCent, double XEndPos, double YEndPos, long Direction);
 long	_stdcall (cmmIxArc3PStart)		(long MapIndex, double P2X, double P2Y, double P3X, double P3Y, double EndAngle);
 long	_stdcall (cmmIxArc3P)			(long MapIndex, double P2X, double P2Y, double P3X, double P3Y, double EndAngle, long IsBlocking);
 long	_stdcall (cmmIxArc3PToStart)		(long MapIndex, double P2X, double P2Y, double P3X, double P3Y, double EndAngle);
 long	_stdcall (cmmIxArc3PTo)			(long MapIndex, double P2X, double P2Y, double P3X, double P3Y, double EndAngle, long IsBlocking);
 long	_stdcall (cmmIxIsDone) 			(long MapIndex, long *IsDone);
 long	_stdcall (cmmIxWaitDone) 		(long MapIndex, long IsBlocking);
 long	_stdcall (cmmIxStop) 			(long MapIndex, long IsWaitComplete, long IsBlocking);
 long	_stdcall (cmmIxStopEmg) 			(long MapIndex);
 long	_stdcall (cmmIxxHelOnceSetSpeed)	(long HelId, long Master, long SpeedMode, double WorkSpeed, double Acc, double Dec);
 long	_stdcall (cmmIxxHelOnceGetSpeed) (long HelId, long *SpeedMaster, long *SpeedMode, double *WorkSpeed, double *Acc, double *Dec);
 long	_stdcall (cmmIxxHelOnce) 		(long HelId, long NumAxes, long* AxisList, double* CoordList, double ArcAngle, double *DistU, long IsBlocking);
 long	_stdcall (cmmIxxHelOnceStart)	(long HelId, long NumAxes, long* AxisList, double* CoordList, double ArcAngle, double *DistU);
 long	_stdcall (cmmIxxSplineBuild)		(double* InArray, long NumInArray, double* OutArray, long NumOutArray);

//====================== External Switch Move FUNCTIONS =======================================//
 long	_stdcall (cmmExVMoveStart)		(long Axis);
 long	_stdcall (cmmExMoveStart) 		(long Axis, double Distance);
 long	_stdcall (cmmExMoveToStart)		(long Axis, double Position);

//====================== Manual Pulsar FUNCTIONS ==============================================//
 long	_stdcall (cmmPlsrSetInMode)		(long Axis, long InputMode, long IsInverse);
 long	_stdcall (cmmPlsrGetInMode)		(long Axis, long* InputMode, long* IsInverse);
 long _stdcall (cmmPlsrSetGain)		(long Axis, long GainFactor, long DivFactor);
 long _stdcall (cmmPlsrGetGain)		(long Axis, long* GainFactor, long* DivFactor);
 long	_stdcall (cmmPlsrHomeMoveStart)	(long Axis, long HomeType);
 long	_stdcall (cmmPlsrMoveStart)		(long Axis, double Distance);
 long	_stdcall (cmmPlsrMove) 			(long Axis, double Distance, long IsBlocking);
 long	_stdcall (cmmPlsrMoveToStart)	(long Axis, double Position);
 long	_stdcall (cmmPlsrMoveTo) 		(long Axis, double Position, long IsBlocking);
 long	_stdcall (cmmPlsrVMoveStart)		(long Axis);
 long	_stdcall (cmmPlsrIsActive)		(long Axis, long *IsActive);

//====================== MASTER/SLAVE FUNCTIONS ===============================================//
 long	_stdcall (cmmMsRegisterSlave) 	(long Axis, double MaxSpeed, long IsInverse);
 long	_stdcall (cmmMsUnregisterSlave)	(long Axis);
 long _stdcall (cmmMsCheckSlaveState)	(long SlaveAxis, long* SlaveState);
 long _stdcall (cmmMsGetMasterAxis) 	(long SlaveAxis, long* MasterAxis);

//====================== Overriding FUNCTIONS =================================================//
 long	_stdcall (cmmOverrideSpeedSet) 		(long Axis);
 long	_stdcall (cmmOverrideSpeedSetAll)	(long NumAxes, long* AxisList);
 long	_stdcall (cmmOverrideMove) 		(long Axis, double NewDistance, long* IsIgnored);
 long	_stdcall (cmmOverrideMoveTo) 		(long Axis, double NewPosition, long* IsIgnored);
 long	_stdcall (cmmOverrideMoveTo_Smc) 	(long Axis, long StopCounter);

//====================== LIST-MOTION FUNCTIONS ================================================//
 long	_stdcall (cmmLmMapAxes) 			(long LmIndex, long MapMask1, long MapMask2);
 long	_stdcall (cmmLmBeginList) 		(long LmIndex);
 long	_stdcall (cmmLmEndList) 			(long LmIndex);
 long	_stdcall (cmmLmStartMotion)		(long LmIndex);
 long	_stdcall (cmmLmAbortMotion)		(long LmIndex);
 long	_stdcall (cmmLmAbortMotionEx)	(long LmIndex, double DecelT_sec);
 long	_stdcall (cmmLmIsDone) 			(long LmIndex, long *IsDone);
 long	_stdcall (cmmLmWaitDone)			(long LmIndex, long IsBlocking);
 long	_stdcall (cmmLmCurSequence)		(long LmIndex, long *SeqIndex);
 long	_stdcall (cmmLmImmediacySet)		(long LmIndex);
 long _stdcall (cmmLmDoPutOne) 		(long LmIndex, HANDLE hDoDevice, long Channel, long OutState);
 long _stdcall (cmmLmDoPutMulti)		(long LmIndex, HANDLE hDoDevice, long ChannelGroup, long Mask, long OutStates);
 long _stdcall (cmmLmDoPulseOne)		(long LmIndex, HANDLE hDoDevice, long Channel, long OutState, long Duration);
 long _stdcall (cmmLmDoPulseMulti)		(long LmIndex, HANDLE hDoDevice, long ChannelGroup,
				long Mask, long OutStates, long Duration);

//====================== ° FUNCTIONS ===================================================//
 long	_stdcall (cmmStSetCount) 		(long Axis, long Target, long Count);
 long	_stdcall (cmmStGetCount) 		(long Axis, long Source, long* Count);
 long	_stdcall (cmmStSetPosition)		(long Axis, long Target, double Position);
 long	_stdcall (cmmStGetPosition)		(long Axis, long Source, double* Position);
 long	_stdcall (cmmStGetSpeed) 		(long Axis, long Source, double* Speed);
 long	_stdcall (cmmStReadMotionState)	(long Axis, long* MotStates);
 long	_stdcall (cmmStReadMioStatuses)	(long Axis, long* MioStates);
 long	_stdcall (cmmStGetMstString)		(long MstCode, char *Buffer, long BufferLen);
 long _stdcall (cmmMstAll_SetCfg)		(long AxisMask1, long AxisMask2, long DataMask);
 long _stdcall (cmmMstAll_GetCfg)		(long *AxisMask1, long *AxisMask2, long *DataMask);
 long _stdcall (cmmMstAll_ManScan)		(TCmMstAll *pBuf);
 long _stdcall (cmmMstAxis_ManScan)	(int nAxis, TAxisMstPack *pBuf);
 long _stdcall (cmmMstAll_AutoStart)	(long TimerInterv);
 long _stdcall (cmmMstAll_AutoStop)	();
 TCmMstAll* _stdcall (cmmMstAll_AutoGetBuf) (void);
 TAxisMstPack* _stdcall (cmmMstAxis_AutoGetBuf)	(int nAxis);
 long _stdcall (cmmMstAll_AutoGetData)	(TCmMstAll *pBuf, long IsFrameSync);
 long _stdcall (cmmMstAll_AutoGetInfo)	(long *ScanCount, long *ScanInerv, long *ScanConsT);
 long _stdcall (cmmMstAll_AutoGetInfo2) (long AxisInDev, long *ScanCount, long *ScanInerv, long *ScanConsT);

//====================== INTERRUPT FUNCTIONS ==================================================//
 long	_stdcall (cmmIntSetMask)			(long Axis, long Mask);
 long	_stdcall (cmmIntGetMask)			(long Axis, long* Mask);
 long _stdcall (cmmIntHandlerSetup)	(long HandlerType, HANDLE Handler, unsigned int nMessage, LPVOID lParam);
 long _stdcall (cmmIntHandlerEnable)	(long IsEnable);
 long	_stdcall (cmmIntReadFlag)		(long *IntFlag1, long *IntFlag2);
 long	_stdcall (cmmIntReadErrorStatus)	(long Axis, long *ErrState);
 long	_stdcall (cmmIntReadEventStatus)	(long Axis, long *EventState);

//====================== LATCH FUNCTIONS =======================================================//
 long	_stdcall (cmmLtcIsLatched)		(long Axis, long *IsLatched);
 long	_stdcall (cmmLtcReadLatch)		(long Axis, long Counter, double* LatchedPos);
 long	_stdcall (cmmLtcQue_SetCfg)		(long Axis, long QueSize, long LtcTargCntr);
 long	_stdcall (cmmLtcQue_GetCfg)		(long Axis, long* pQueSize, long* pLtcTargCntr);
 long	_stdcall (cmmLtcQue_SetEnable)	(long Axis, long IsEnabled);
 long	_stdcall (cmmLtcQue_GetEnable)	(long Axis, long* pIsEnabled);
 long	_stdcall (cmmLtcQue_GetItemCount)(long Axis, long* pLtcItemCount);
 long	_stdcall (cmmLtcQue_ResetItemCount)(long Axis);
 long	_stdcall (cmmLtcQue_Deque)		(long Axis, double* pLtcData);
 long	_stdcall (cmmLtcQue_PeekAt)		(long Axis, long Index, double* pLtcData);

//====================== Position Compare FUNCTIONS ===========================================//
 long	_stdcall (cmmCmpErrSetConfig) 	(long Axis, double Tolerance, long IsEnable);
 long	_stdcall (cmmCmpErrGetConfig) 	(long Axis, double* Tolerance, long* IsEnabled);
 long	_stdcall (cmmCmpGenSetConfig)	(long Axis, long CmpSrc, long CmpMethod, long CmpAction, double CmpData);
 long	_stdcall (cmmCmpGenGetConfig) 	(long Axis, long* CmpSrc, long* CmpMethod, long* CmpAction, long* CmpData);
 long	_stdcall (cmmCmpTrgSetConfig) 	(long Axis, long CmpSrc, long CmpMethod);
 long	_stdcall (cmmCmpTrgGetConfig) 	(long Axis, long* CmpSrc, long* CmpMethod);
 long	_stdcall (cmmCmpTrgSetOneData) 	(long Axis, double Data);
 long	_stdcall (cmmCmpTrgGetCurData) 	(long Axis, double* Data);
 long	_stdcall (cmmCmpTrgContRegTable)	(long Axis, double* Buffer, long NumData);
 long	_stdcall (cmmCmpTrgContBuildTable) (long Axis, double StartData, double Interval, long NumData);
 long	_stdcall (cmmCmpTrgContStart) 	(long Axis);
 long	_stdcall (cmmCmpTrgContStop)  	(long Axis);
 long	_stdcall (cmmCmpTrgContIsActive)	(long Axis, long *IsActive);
 long	_stdcall (cmmCmpTrgHigh_WriteData)	(long Axis, long CMPH_No, double IniPos, double Interval);
 long	_stdcall (cmmCmpTrgHigh_ReadData)	(long Axis, long *CMPH_No, double *IniPos, double *Interval);
 long	_stdcall (cmmCmpTrgHigh_Start)	(long Axis);
 long	_stdcall (cmmCmpTrgHigh_Stop)	(long Axis);
 long	_stdcall (cmmCmpTrgHigh_Check)	(long Axis, long *IsActive, long *OutCount);

 long	_stdcall (cmmCmpQue_SetEnable)	(long Axis, long IsEnable);
 long	_stdcall (cmmCmpQue_GetEnable)	(long Axis, long* IsEnabled);
 long	_stdcall (cmmCmpQue_SetQueSize)	(long Axis, long QueSize);
 long	_stdcall (cmmCmpQue_GetQueSize)	(long Axis, long* QueSize);
 long	_stdcall (cmmCmpQue_Enque)		(long Axis, long CmpSrc, long CmpMethod, long CmpData);
 long	_stdcall (cmmCmpQue_GetEnqueCnt)	(long Axis, long* EnqueCnt);
 long	_stdcall (cmmCmpQue_GetOutCnt)	(long Axis, long* OutCnt);
 long	_stdcall (cmmCmpQue_SetOutCnt)	(long Axis, long OutCnt);
 long	_stdcall (cmmCmpQue_SetLtcLinkMode) (long Axis, long Enable, long SrcLtcCnt, long CmpSrc, long CmpMethod, long Offset);
 long	_stdcall (cmmCmpQue_GetLtcLinkMode) (long Axis, long* Enable, long* SrcLtcCnt, long* CmpSrc, long* CmpMethod, long* Offset);

 long _stdcall (cmmGnSetAxisName)		(long Axis, const char *szAxisName);
 long _stdcall (cmmGnGetAxisName)		(long Axis, char *pszAxisName);
 long	_stdcall (cmmCmpTrgSetAxis) 		(long Axis, long CmpAxis);
 long	_stdcall (cmmCmpTrgGetAxis)		(long Axis, long* CmpAxis);

//====================== Digital In/Out FUNCTIONS =============================================//
 long _stdcall (cmmDiSetInputLogic)	(long Channel, long InputLogic);
 long _stdcall (cmmDiGetInputLogic)	(long Channel, long* InputLogic);
 long	_stdcall (cmmDiGetOne) 			(long Channel, long* InputState);
 long	_stdcall (cmmDiGetMulti) 		(long IniChannel, long NumChannels, long* InputStates);
 long	_stdcall (cmmDiGetOneF) 			(long Channel, long CutoffTime_us, long* InputState);
 long	_stdcall (cmmDiGetMultiF) 		(long IniChannel, long NumChannels, long CutoffTime_us, long* InputStates);
 long _stdcall (cmmDoSetOutputLogic)	(long Channel, long OutputLogic);
 long _stdcall (cmmDoGetOutputLogic)	(long Channel, long* OutputLogic);
 long	_stdcall (cmmDoPutOne) 			(long Channel, long OutState);
 long	_stdcall (cmmDoGetOne) 			(long Channel, long* OutState);
 long	_stdcall (cmmDoPulseOne)			(long Channel, long IsOnPulse, long dwDuration, long IsWaitPulseEnd);
 long	_stdcall (cmmDoPutMulti) 		(long IniChannel, long NumChannels, long OutStates);
 long	_stdcall (cmmDoGetMulti) 		(long IniChannel, long NumChannels, long* InputStates);
 long	_stdcall (cmmDoPulseMulti)		(long IniChannel, long NumChannels, long OutStates, long dwDuration, long IsWaitPulseEnd);

//====================== Advanced FUNCTIONS ===================================================//

 long _stdcall (cmmAdvGetNumAvailAxes)	(long *NumAxes);
 long _stdcall (cmmAdvGetNumDefinedAxes)	(long *NumAxes);
 long _stdcall (cmmAdvGetNumAvailDioChan) (long IsInputChannel, long* NumChannels);
 long _stdcall (cmmAdvGetNumDefinedDioChan) (long IsInputChannel, long* NumChannels);
 long	_stdcall (cmmAdvGetMotDeviceId) 	(long Axis, long *DeviceId);
 long	_stdcall (cmmAdvGetMotDevInstance)  (long Axis, long *DevInstance);
 long	_stdcall (cmmAdvGetDioDeviceId) 	(long Axis, long IsInputChannel, long *DeviceId);
 long	_stdcall (cmmAdvGetDioDevInstance)  (long Axis, long IsInputChannel, long *DevInstance);
 long	_stdcall (cmmAdvGetDeviceHandle)	(long DeviceId, long DevInstance, HANDLE *DevHandle);
 long	_stdcall (cmmAdvWriteMainSpace)	(long Axis, long Addr, long Value);
 long	_stdcall (cmmAdvReadMainSpace)	(long Axis, long Addr, long *Value);
 long	_stdcall (cmmAdvWriteRegister)	(long Axis, long RegisterNo, long RegVal);
 long	_stdcall (cmmAdvReadRegister) 	(long Axis, long RegisterNo, long* RegVal);
 long _stdcall (cmmAdvGetMioCfg1unsigned long) (long Axis, long* Mio1unsigned long);
 long _stdcall (cmmAdvSetMioCfg1unsigned long) (long Axis, long Mio1unsigned long);
 long _stdcall (cmmAdvSetToolboxMode) 	(long EnInterrupt);
 long _stdcall (cmmAdvGetString) 		(long Axis, long StringID, char* szBuffer);
 long _stdcall (cmmAdvErcOut) 			(long Axis, long IsWaitOff);
 long _stdcall (cmmAdvErcReset) 		(long Axis);
 long _stdcall (cmmAdvSetExtOptions)  	(long OptionId, long lParam1, long lParam2, double fParam1, double fParam2);
 long _stdcall (cmmAdvEnumMotDevices)	(TMotDevEnum *EnumBuffer);
 long _stdcall (cmmAdvGetMotDevMap)	(TMotDevMap *MapBuffer);
 long _stdcall (cmmAdvEnumDioDevices)	(TDioDevEnum *EnumBuffer);
 long _stdcall (cmmAdvGetDioDevMap)	(TDioDevMap *MapBuffer);
 long _stdcall (cmmAdvInitFromCmeBuffer) (TCmeData_V2 *pCmeBuffer);
 long _stdcall (cmmAdvInitFromCmeBuffer_MapOnly) (TCmeData_V2 *pCmeBuffer, int nMapType);
 long _stdcall (cmmAdvGetLatestCmeFile) (/*[out] */char *szCmeFile);
 long _stdcall (cmmAdvGetAxisCapability) (long Channel, long CapId, long *CapBuffer);

//====================== DEBUG-LOGGING FUNCTIONS ==============================================//
 long	_stdcall (cmmDlogSetup) 			(long Level, const char* szLogFile);
 long	_stdcall (cmmDlogAddComment)		(const char* szComment);
 long	_stdcall (cmmDlogGetCurLevel)	(long* CurLevel);
 long	_stdcall (cmmDlogGetCurFilePath) (char* szFilePath);
 long	_stdcall (cmmDlogEnterManMode)	(int nMode);
 long	_stdcall (cmmDlogExitManMode)	(void);

//====================== ERROR HANDLING FUNCTIONS =============================================//
 long	_stdcall (cmmErrGetLastCode) 	(long *ErrorCode);
 long	_stdcall (cmmErrClearLastCode) 	(void);
 short _stdcall (cmmErrParseAxis) 		(long ErrorCode);
 short _stdcall (cmmErrParseReason) 	(long ErrorCode);
 long	_stdcall (cmmErrGetString) 		(long ErrorCode, char *Buffer, long BufferLen);
 long	_stdcall (cmmErrShowLast)		(HWND ParentWnd);
 long	_stdcall (cmmErrSetSkipShowMessage) (long IsSkip);
 long	_stdcall (cmmErrGetSkipShowMessage) (long *IsSkip);
 long	_stdcall (cmmErrSetEnableAutoMessage) (long Enable);
 long	_stdcall (cmmErrGetEnableAutoMessage) (long *Enabled);

//====================== Utility FUNCTIONS ===================================================//
 long _stdcall (cmmUtlProcessWndMsgS)	(HWND WndHandle, long *IsEmpty);
 long _stdcall (cmmUtlProcessWndMsgM)	(HWND WndHandle, long TimeOut, long *IsTimeOuted);
 long _stdcall (cmmUtlReadUserTable)	(long nAddress, long nSize, unsigned char* pBuffer);
 long _stdcall (cmmUtlWriteUserTable)	(long nAddress, long nSize, unsigned char* pBuffer);
 long _stdcall (cmmUtlDelayMicroSec)	(long Delay_us);

//====================== Extended List Motion FUNCTIONS ===================================================//
 long _stdcall (cmmLmxStart)			(long LmIndex, long AxisMask1, long AxisMask2);
 long _stdcall (cmmLmxPause)			(long LmIndex);
 long _stdcall (cmmLmxResume)			(long LmIndex, long IsClearQue);
 long _stdcall (cmmLmxEnd)				(long LmIndex);
 long	_stdcall (cmmLmxSetSeqMode)		(long LmIndex, long SeqMode);
 long	_stdcall (cmmLmxGetSeqMode)		(long LmIndex, long SeqMode);
 long	_stdcall (cmmLmxSetNextItemId)	(long LmIndex, long SeqId);
 long	_stdcall (cmmLmxGetNextItemId)	(long LmIndex, long *SeqId);
 long	_stdcall (cmmLmxSetNextItemParam)(long LmIndex, long ParamIdx, long ParamData);
 long	_stdcall (cmmLmxGetNextItemParam)(long LmIndex, long ParamIdx, long *ParamData);
 long	_stdcall (cmmLmxGetRunItemParam)	(long LmIndex, long ParamIdx, long *ParamData);
 long	_stdcall (cmmLmxGetRunItemStaPos)(long LmIndex, long Axis, double* Position);
 long	_stdcall (cmmLmxGetRunItemTargPos)(long LmIndex, long Axis, double* Position);
 long	_stdcall (cmmLmxGetSts)			(long LmIndex, long LmxStsId, long *LmxStsVal);

 long _stdcall (cmmPtAddItem)          (int head_no, PT_MOTION_TAB pt, int final_flag);
 long _stdcall (cmmPtIsDone)           (int groupID, double in_time);
 long _stdcall (cmmPtSetHold)          (int groupId, int isHold);
// long _stdcall (cmmPtClearQue)         (void);
 long _stdcall (cmmPtMsConfig)         (MOTION_CONFIG *msConfig, int ms_count);
 long _stdcall (cmmPtHeadConfig)       (int *headConfig, int head_count);
 long _stdcall (cmmPtHomeSetConfig)     (long Axis, long HomeDir, long mode_flags, long CW_LimitPlus, long CCW_LimitMinus, int z_count, int move_offset, int set_offset);
 long _stdcall (cmmPtHomeSetSpeedPattern)  (long Axis, long SpeedMode, double Accel, double Decel, double reverse_speed, double forward_speed, double minimum_speed);
 long _stdcall (cmmPtHomeMoveStart)    (long Axis);
 long _stdcall (cmmPtHomeIsDone)       (long Axis);
 long _stdcall (cmmPtStop)             (int groupId);
 long _stdcall (cmmPtGetCurSeq)        (int groupID);
// int _stdcall (cmmPtInit)       (void);
 long _stdcall (cmmPtAddItem2)		(int head_no, int pointCnt, double *position, double *time, int final_flag);

 long _stdcall (cmmIxSetMasterAxis)	(long nAxis, long bSetValue);
 long _stdcall (cmmIxGetMasterAxis)	(long nAxis, long *bSetValue);
 long _stdcall (cmmIxGetFxInfo)	(long nMapIndex, long *bIsFx, long *nMaster);
 long _stdcall (cmmIxSmartStop)	(long nMapIndex, double decelTimeSec);

 long _stdcall (cmmSpinSpeedMoveStart) (long Axis, long dir, long SpeedMode, double WorkSpeed, double Accel, double Decel);